type trbmpdata=array[0..199,0..319] of byte;
     trbmp=object
           rpl,gpl,bpl:^trbmpdata;
           procedure load(s:string);
           procedure getrgb(x,y:integer;var r,g,b:byte);
           procedure destroy;
           end;
     trheader=record
              bfType          :word;
              bfSize          :longint;
              bfReserved1     :word;
              bfReserved2     :word;
              bfOffBits       :longint;
              biSize          :longint;
              biWidth         :longint;
              biHeight        :longint;
              biPlanes        :word;
              biBitCount      :word;
              biCompression   :longint;
              biSizeImage     :longint;
              biXPelsPerMeter :longint;
              biYPelsPerMeter :longint;
              biClrUsed       :longint;
              biClrImportant  :longint;
              end;

procedure trbmp.load;
var f:file;
    head:trheader;
    palette:array[0..255] of record b,g,r,u:byte end;
    line:array[0..10000] of byte;
    x,y,z,i,j:integer;
    w:word;
begin
   assign(f,s);
   filemode:=0;
   reset(f,1);
   new(rpl); fillchar(rpl^,sizeof(trbmpdata),0);
   new(gpl); fillchar(gpl^,sizeof(trbmpdata),0);
   new(bpl); fillchar(bpl^,sizeof(trbmpdata),0);
   blockread(f,head,sizeof(head));
   if head.bicompression<>0 then halt;
   if head.biheight<>200 then halt;
   if head.biwidth<>320 then halt;
   case head.biBitcount of
      4:
      begin
         blockread(f,palette,64);
         seek(f,head.bfOffbits);
         for x:=head.biHeight-1 downto 0 do begin
            blockread(f,line,head.biwidth div 2,w);
            for y:=0 to head.biwidth div 2-1 do begin
               bpl^[x,y*2-1]:=palette[line[y] div 16].b;
               gpl^[x,y*2-1]:=palette[line[y] div 16].g;
               rpl^[x,y*2-1]:=palette[line[y] div 16].r;
               bpl^[x,y*2-0]:=palette[line[y] mod 16].b;
               gpl^[x,y*2-0]:=palette[line[y] mod 16].g;
               rpl^[x,y*2-0]:=palette[line[y] mod 16].r;
            end;
         end;
      end;

      8:
      begin
         blockread(f,palette,1024);
         seek(f,head.bfOffbits);
         for x:=head.biHeight-1 downto 0 do begin
            blockread(f,line,head.biwidth,w);
            for y:=0 to head.biwidth-1 do begin
               bpl^[x,y]:=palette[line[y]].b;
               gpl^[x,y]:=palette[line[y]].g;
               rpl^[x,y]:=palette[line[y]].r;
            end;
         end;
      end;

      24:
      begin
         seek(f,head.bfOffbits);
         for x:=head.biHeight-1 downto 0 do begin
            blockread(f,line,head.biwidth*3);
            for y:=0 to head.biwidth-1 do begin
               bpl^[x,y]:=line[y*3+0];
               gpl^[x,y]:=line[y*3+1];
               rpl^[x,y]:=line[y*3+2];
            end;
         end;
      end;

   else halt;
   end;
   close(f);
end;

procedure trbmp.destroy;
begin
   if rpl<>nil then dispose(rpl); rpl:=nil;
   if gpl<>nil then dispose(gpl); gpl:=nil;
   if bpl<>nil then dispose(bpl); bpl:=nil;
end;

procedure trbmp.getrgb;
begin
   r:=rpl^[x,y];
   g:=gpl^[x,y];
   b:=bpl^[x,y];
end;


